﻿using System;
using System.Collections;
using System.Data;

using DevExpress.Utils;
using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Views.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.gridView.InitializeView
            (
                true,                           // Multi Select
                GridMultiSelectMode.CellSelect, // Grid Multi Select Mode
                DrawFocusRectStyle.CellFocus,   // Draw Focus Rect Style
                true,                           // Show Indicator
                true,                           // Show Column Headers
                true,                           // Allow Column Moving
                true,                           // Allow Column Resizing
                true,                           // Allow Filter
                true,                           // Allow Sort
                false,                          // Allow Cell Merge
                EditorShowMode.Default,         // Editor Show Mode
                false                           // Editable
            );

            this.gridView.OptionsBehavior.AutoPopulateColumns = true;

            this.gridControl.DataSource = new nwindDataSetTableAdapters.ProductsTableAdapter().GetData();

            this.gridView.BestFitColumns();

            this.executeButton.Click += executeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 실행하기 버튼 클릭시 처리하기 - executeButton_Click(sender, e)

        /// <summary>
        /// 실행하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void executeButton_Click(object sender, EventArgs e)
        {
            ArrayList arrayList = new ArrayList();

            int[] selectedRowHandleArray = this.gridView.GetSelectedRows();

            for(int i = 0; i < selectedRowHandleArray.Length; i++)
            {
                int selectedRowHandle = selectedRowHandleArray[i];

                if(selectedRowHandle >= 0)
                {
                    arrayList.Add(this.gridView.GetDataRow(selectedRowHandle));
                }
            }

            try
            {
                this.gridView.BeginUpdate();

                for(int i = 0; i < arrayList.Count; i++)
                {
                    DataRow row = arrayList[i] as DataRow;

                    row["Discontinued"] = !(bool)row["Discontinued"];
                }
            }
            finally
            {
                this.gridView.EndUpdate();
            }
        }

        #endregion
    }
}